#!/bin/sh

color1="c 250 80 50"
color2="c 250 180 200"
color3="c 100 40 100"
color4="c 50 200 80"
color5="c 80 120 220"
color6="c 240 240 0"
color7="c 255 255 255"

test -z "$SCREEN_WIDTH" && echo "error: please run as 'fbenv paint.sh'" && exit 1

W="$SCREEN_WIDTH"
H="$SCREEN_HEIGHT"

export FBDEV=/dev/fb0
export TOUCHDEVICE=/dev/input/event0

# Paletten und Farbbuttons an oberen Rand zeichnen
cat << EOF | fbdraw > /dev/null
m 0 0
c 30 30 30
r $W $H
$color1
m 0 0
r 64 64
$color2
m 64 0
r 64 64
$color3
m 128 0
r 64 64
$color4
m 192 0
r 64 64
$color5
m 256 0
r 64 64
$color6
m 320 0
r 64 64
$color7
m 384 0
r 64 64
o 448 0
$(zcat images/hazard.txt.gz)
o 0 0
EOF

# touch auf die entsprechenden buttons fuehrt zu entsprechenden draw befehlen in der pipe
# rest zeichnet mit 24px breitem pinsel
# aktuelle zeichenfarbe in rechter oberer ecke
./fbtouch |\
stdbuf -i0 -o0 sed "s/# touch 1 .*/$color1/g" |\
stdbuf -i0 -o0 sed "s/# touch 2 .*/$color2/g" |\
stdbuf -i0 -o0 sed "s/# touch 3 .*/$color3/g" |\
stdbuf -i0 -o0 sed "s/# touch 4 .*/$color4/g" |\
stdbuf -i0 -o0 sed "s/# touch 5 .*/$color5/g" |\
stdbuf -i0 -o0 sed "s/# touch 6 .*/$color6/g" |\
stdbuf -i0 -o0 sed "s/# touch 7 .*/$color7/g" |\
stdbuf -i0 -o0 sed "s/# touch [0-9]* /m /g;s/$/\nr 24 24/g;s/$/\nm $((W-24)) 0/g" |\
stdbuf -i0 -o0 fbdraw
