/*

reinhard@finalmedia.de
Di 14. Mär 14:36:55 CET 2023

aquire mouse coords, click and wheel-scroll events
and write to stdout. line by line.

*/

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>

int main()
{
	int fd;
	unsigned char ie[5];
	char x=0,y=0;
	int absolute_x=0,absolute_y=0,tile_id=0;

	// default env if not set
	setenv("SCREEN_WIDTH","1920",0);
	setenv("SCREEN_HEIGHT","1080",0);
	setenv("MOUSEDEVICE","/dev/input/mice",0);

	int max_width = atoi(getenv("SCREEN_WIDTH"));
	int max_height = atoi(getenv("SCREEN_HEIGHT"));

	if((fd = open(getenv("MOUSEDEVICE"), O_RDWR | O_NONBLOCK )) != -1)
	{

	// enable mousewheel support (intellimouse mode)
	write(fd, "\xf3\xc8\xf3\x64\xf3\x50", 6);
	read(fd,NULL,1);

	while(1)
    	{

	usleep(1400);

	if(read(fd, &ie, sizeof(ie))!=-1)
        {

	x=(char) ie[1];
	y=(char) ie[2];

	absolute_x+=x;
	absolute_y-=y;

	if (absolute_x<0) { absolute_x=0; }
	if (absolute_y<0) { absolute_y=0; }
	if (absolute_x>max_width)  { absolute_x=max_width;  }
	if (absolute_y>max_height) { absolute_y=max_height; }

	tile_id=1+((absolute_y/64)*(max_width/64))+(absolute_x/64);

	printf("%i %i\n",absolute_x,absolute_y);

        if ((ie[0] & 0x01)>0)	{ printf("# click_left %i %i %i\n", tile_id,absolute_x,absolute_y); }
        if ((ie[0] & 0x02)>0)	{ printf("# click_right %i %i %i\n", tile_id,absolute_x,absolute_y); }
        if ((ie[0] & 0x04)>0)	{ printf("# click_middle %i %i %i\n", tile_id,absolute_x,absolute_y); }
	if (ie[3]==0xff)	{ printf("# scroll_up %i %i %i\n", tile_id,absolute_x,absolute_y); }
	if (ie[3]==0x01)	{ printf("# scroll_down %i %i %i\n", tile_id,absolute_x,absolute_y); }

	fflush(stdout);
        }

	}

    close(fd);
    }
return 0;
}
