/*

reinhard@finalmedia.de
Fr 17. Mär 19:04:16 CET 2023
Sa 29. Apr 19:45:03 CEST 2023 support for multitouch to singletouch translation

Read Touchscreen events
and output coordinates on touch

FOR MULTITOUCH SCREENS, SET ENVIRONMENT VAR "MULTITOUCH"
example usage:  MULTITOUCH=1 fbenv fbtouch

normal usage: fbenv fbtouch

*/

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

int main()
{

    int fd;
    unsigned char ie[32];
    unsigned char evs=8;
    unsigned char readsize=16;

    int absolute_x=0;
    int absolute_y=0;
    int tile_id=0;

    setenv("SCREEN_WIDTH","800",0);
    setenv("SCREEN_HEIGHT","400",0);
    int max_width = atoi(getenv("SCREEN_WIDTH"));
    int max_height = atoi(getenv("SCREEN_HEIGHT"));

    setenv("TOUCHDEVICE","/dev/input/event0",0);

    if (getenv("MULTITOUCH")) { evs=16; readsize=32; }
    if (readsize>sizeof(ie)) { return 1; }

    if((fd = open(getenv("TOUCHDEVICE"), O_RDONLY | O_NONBLOCK)) != -1) {


    while (1) {

	usleep(140);

	if(read(fd, &ie, readsize)!=-1)
        {

        	if (ie[evs] == 0x03) {

			// endianess!!!

			if (ie[evs+2] == 0x00) { absolute_x=(int) ie[evs+5] << 8 | ie[evs+4]; }
        		if (ie[evs+2] == 0x01) { absolute_y=(int) ie[evs+5] << 8 | ie[evs+4]; }

        		if (absolute_x>max_width)  { absolute_x=max_width;  }
			if (absolute_y>max_height) { absolute_y=max_height; }

        		if (absolute_x>0 && absolute_y>0) {

			tile_id=1+((absolute_y/64)*(max_width/64))+(absolute_x/64);

			printf("# touch %d %d %d\n", tile_id, absolute_x, absolute_y);
			fflush(stdout);

			absolute_x=0;
			absolute_y=0;
			}

		}
	}
    }

    close(fd);

   }

return 0;
}

